
package example.shop.servlets;

import example.shop.data.DataManager;
import example.shop.data.ItemInfo;
import example.shop.Constants;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import javax.servlet.ServletException;
import javax.servlet.ServletConfig;
import java.io.IOException;
import java.util.Hashtable;

public class BuyServlet extends HttpServlet {

    public static final String ACTION_BUY    = "add";
    public static final String ACTION_UNBUY  = "unbuy";

    public static final String PARAMETER_ACTION        = "action";
    public static final String PARAMETER_NAME          = "name";

    public static final String ITEM_BOUGHT_FORWARD = "listall.jsp";

    public ServletConfig mConfig;

    public void init(ServletConfig aConfig) throws ServletException {
        mConfig = aConfig;
    }

    public void doGet( HttpServletRequest request,
                       HttpServletResponse response)
            throws ServletException, IOException {

        //Get input parameters
        String action = request.getParameter(PARAMETER_ACTION);
        if(action == null) {
            action = "";
        }

        //Initialize Session Objects
        final HttpSession session = request.getSession();
        Hashtable shopCart = (Hashtable) session.getAttribute(Constants.SHOPPING_CART);
        if (shopCart == null) {
            shopCart = new Hashtable();
            session.setAttribute(Constants.SHOPPING_CART, shopCart);
        }

        if(action.equalsIgnoreCase(ACTION_UNBUY)) {

            String name = request.getParameter(PARAMETER_NAME);
            if(name == null) {
                name = "";
            }

            //Update session of user
            try {
                shopCart.remove(name);
            } catch(Throwable _) {
                //If item does not exist - do nothing
            }

        } else {
            String name = request.getParameter(PARAMETER_NAME);
            if(name == null) {
                name = "";
            }

            String price = request.getParameter("price");
            if(price == null) {
                price = "";
            }

            //Update session of user
            shopCart.put(name,price);
        }

        response.sendRedirect(ITEM_BOUGHT_FORWARD);
    }

	public void doPost( HttpServletRequest request,
			    HttpServletResponse response)
			    throws ServletException, IOException {
		doGet(request, response);
	}
}
