/*
 * Created by IntelliJ IDEA.
 * User: rajchom
 * Date: Jun 4, 2002
 * Time: 3:51:59 PM
 * To change template for new class use
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package example.shop.servlets;

import example.shop.Constants;
import example.shop.data.DataManager;
import example.shop.data.ItemInfo;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import javax.servlet.ServletException;
import javax.servlet.ServletConfig;
import javax.servlet.RequestDispatcher;
import java.io.IOException;

public class ItemActionServlet extends HttpServlet {

    public static final String ACTION_ADD    = "add";
    public static final String ACTION_DELETE = "delete";

    public static final String PARAMETER_ACTION        = "action";
    public static final String PARAMETER_NAME          = "name";
    public static final String PARAMETER_PRICE         = "price";
    public static final String PARAMETER_DESCRIPTION   = "description";

    public static final String LIST_ALL_FORWARD = "adminlist.jsp";

    public ServletConfig mConfig;

    public void init(ServletConfig aConfig) throws ServletException {
        mConfig = aConfig;
    }

    public void doGet( HttpServletRequest request,
			   HttpServletResponse response)
			  throws ServletException, IOException {

               //Get input parameters
      		   String action = request.getParameter(PARAMETER_ACTION);
               if(action == null) {
                  action = "";
               }

               //Initialize Database Access
               final HttpSession session = request.getSession();
               DataManager dataMan = (DataManager) session.getAttribute(Constants.SESSIONKEY_DATAMAN);

               if(action.equalsIgnoreCase(ACTION_ADD)) {
                   String name = request.getParameter(PARAMETER_NAME);
                   if(name == null) {
                      name = "";
                   }

                   String priceStr = request.getParameter(PARAMETER_PRICE);
                   if(priceStr == null) {
                      priceStr = "0";
                   }
                   Double price = null;
                   try {
                       price = new Double(priceStr);
                   }catch(NumberFormatException _) {
                       price = new Double(0);
                   }

                   String description = request.getParameter(PARAMETER_DESCRIPTION);
                   if(description == null) {
                      description = "";
                   }

                   ItemInfo info = new ItemInfo(name,description,price);
                   dataMan.addItemInfo(info);

               } else {
                   String name = request.getParameter(PARAMETER_NAME);
                   if(name == null) {
                      name = "";
                   }

                   dataMan.deleteItemInfo(name);
               }

               response.sendRedirect(LIST_ALL_FORWARD);
    }

	public void doPost( HttpServletRequest request,
			    HttpServletResponse response)
			    throws ServletException, IOException {
		doGet(request, response);
	}
}
