package example.shop.tags;

import example.shop.Constants;

import javax.servlet.jsp.tagext.TagSupport;
import javax.servlet.jsp.JspException;
import javax.servlet.http.HttpSession;
import javax.servlet.ServletContext;

public class AdminOnlyTag extends TagSupport {


    public static boolean checkIsAdmin (HttpSession aSession, ServletContext aContext) {
        String loggedObj = (String) aSession.getAttribute(Constants.LOGGED_USER);
        String adminUser = (String) aContext.getInitParameter(Constants.CONTEXT_PARAMS_ADMIN_USER_NAME);

        return ((adminUser != null) && (loggedObj != null) && (adminUser.equalsIgnoreCase(loggedObj)));
    }

    public int doStartTag(){

        if (checkIsAdmin(pageContext.getSession(), pageContext.getServletContext())) {
            return EVAL_BODY_INCLUDE;
        } else {
            return SKIP_BODY;
        }
    }

    public int doEndTag() {
        return EVAL_PAGE;
    }
}
