package example.shop.tags;

import example.shop.Constants;

import javax.servlet.jsp.tagext.TagSupport;
import javax.servlet.jsp.JspException;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpServletRequest;
import java.io.IOException;

public class IsLoggedTag extends TagSupport {

    private boolean mIsAdmin = false;

    public int doEndTag() throws JspException {
        String loggedObj = (String) pageContext.getSession().getAttribute(Constants.LOGGED_USER);

        HttpServletResponse resp = (HttpServletResponse)pageContext.getResponse();
        HttpServletRequest req = (HttpServletRequest)pageContext.getRequest();

        if (loggedObj == null) { // user has not logged in, forward him to the beginning

            String redirURL = req.getContextPath();
            try {
                resp.sendRedirect(redirURL);
            } catch (IOException e) {
                e.printStackTrace();
            }

            return SKIP_PAGE;
        } else {
            //If this is admin page and user is not admin - send to index.
            if(mIsAdmin) {
                if (!AdminOnlyTag.checkIsAdmin(pageContext.getSession(), pageContext.getServletContext())) {
                    String redirURL = req.getHeader("Referer");
                    try {
                        resp.sendRedirect(redirURL);
                    } catch (IOException e) {
                        e.printStackTrace();
                    }

                    System.out.println("Not an admin user!!");

                    return SKIP_PAGE;
                } else {

                }
            }

            return EVAL_PAGE;
        }
    }

    public void setIsAdminPage(String aIsAdmin) {
        mIsAdmin = new Boolean(aIsAdmin).booleanValue();
    }

    private void sendRedirect() {


    }
}
