package example.shop.tags;

import example.shop.data.DataManager;
import example.shop.data.ItemInfo;
import example.shop.Constants;

import javax.servlet.jsp.tagext.TagSupport;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import java.io.InputStream;
import java.io.IOException;
import java.util.Properties;
import java.util.Enumeration;
import java.util.Vector;

/**
 *  Tag without body
 *    attributes:
 *       formaction
 */
public class ListTag  extends TagSupport {

    private String mFormAction = null;

    public int doEndTag() throws JspException {

        Vector data = null;
        try {
            data = DataManager.getFromSession(pageContext.getSession()).getData();
        } catch (Exception e) {
            return EVAL_PAGE;
        }

        int page = 0;
        try {
            page = Integer.parseInt(pageContext.getRequest().getParameter(Constants.LIST_PAGE_PARAM));
        } catch (NumberFormatException e) {
            // if no page request parameter specified, assume first page
        }


        int itemsOnPage = Constants.LIST_ITEMS_ON_PAGE_DEFAULT;

        try {
            itemsOnPage = Integer.parseInt(pageContext.getServletContext().getInitParameter(Constants.CONTEXT_PARAM_LIST_ITEMS_ON_PAGE));
        } catch (NumberFormatException e) {
            System.out.println("No context param ITEMS_ON_PAGE specified - using default");
        }


        int startIndex = itemsOnPage*page;

        JspWriter out = pageContext.getOut();

        try {
            out.println("<script language='JavaScript'>");
            out.println("    function doAction(aname, aprice) {");
            out.println("        actionform.name.value = aname;");
            out.println("        actionform.price.value = aprice;");
            out.println("        actionform.submit();");
            out.println("    }");
            out.println("</script>");

            out.println("<table border='1' width='80%' align='center' cellspacing='0'>");
            out.println("<tr>");
            out.println("<td width='30%'>Name</td>");
            out.println("<td width='20%'>Price</td>");
            out.println("<td width='50%'>Description</td>");
            out.println("</tr>");

            for (int i = startIndex; (i < (startIndex + itemsOnPage)) && ( i < data.size()); i++) {
                ItemInfo info = (ItemInfo) data.get(i);

                out.println("<tr>");

                out.print("<td><a href=\"javascript: doAction('" + info.getName() + "', '" + info.getPrice() + "');\">");
                out.print(info.getName());
                out.println("</a></td>");

                out.print("<td align='right'>");
                out.print(info.getPrice());
                out.println("</td>");

                out.println("<td>");
                out.println(info.getDescription());
                out.println("</td>");
                out.println("</tr>");
            }

            out.println("<tr>");
            out.println("    <td colspan='3' align='center'>");

            if (page > 0) {
                out.print("        <a href='?page=");
                out.print(page-1);
                out.println("'>&lt;&lt; Prev page</a>");
            }

            out.println("        &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");

            if (page < (data.size() / itemsOnPage)) {
                out.print("        <a href='?page=");
                out.print(page+1);
                out.println("'>Next page &gt;&gt; </a>");
            }

            out.println("    </td>");
            out.println("</tr>");
            out.println("</table>");

            out.println("<form name='actionform' action='" + mFormAction + "' method='POST'>");
            out.println("	<input type='hidden' name='name'>");
            out.println("	<input type='hidden' name='price'>");
            out.println("</form>");
        } catch (IOException e) {
            e.printStackTrace();
        }

        return EVAL_PAGE;
    }

    public void setFormaction(String aFormAction) {
        mFormAction = aFormAction;
    }
}
