package example.shop.tags;

import example.shop.Constants;
import example.shop.servlets.BuyServlet;

import javax.servlet.jsp.tagext.TagSupport;
import javax.servlet.jsp.tagext.BodyTagSupport;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import java.io.IOException;
import java.util.Hashtable;
import java.util.Enumeration;

public class ShopPageTag extends TagSupport {

    public static final String DEF_TITLE_COLOR = "#9090FF";

    private String mPageTitle = "";
    private String mTitleColor = DEF_TITLE_COLOR;

    public int doStartTag() throws JspException {
        JspWriter out = pageContext.getOut();

        try {
            out.println("<table border='0' cellspacing='0' cellpadding='2' width='90%' height='90%' align='center' valign='middle'>");

            // title
            System.out.println("Title");
            out.println("    <tr bgcolor='" + mTitleColor + "'>");
            out.println("        <td colspan='2' height='1%'>");
            out.println("<table width='100%'><tr><td width='80%' align='center'  valign='middle'>");
            out.println(mPageTitle);
            out.println("</td><td width='10%' align='right'><a href='error.jsp'>Error</a></td>");
            out.println("<td align='right'><a href='logout.jsp'>Logout</a></td>");
            
            out.println("</tr></table>");

            // shopping cart
            out.println("   <tr>");
            out.println("      <td width='20%' valign='top'>");

            out.println(" <b>Shopping cart</b>");
            out.println("<table border='0' cellspacing='0' cellpadding='0' width='100%'>");
            out.println("  <tr bgcolor='#EEEEEE'> <td width='50%'>Name</td> <td>Price</td> </tr>");

            Hashtable data = (Hashtable) pageContext.getSession().getAttribute(Constants.SHOPPING_CART);
            if (data == null) {

            } else {
                Enumeration keys = data.keys();

                while (keys.hasMoreElements()) {
                    String name = (String) keys.nextElement();
                    String price = (String) data.get(name);

                    out.println("<tr> <td><a href='buyServlet?name=" + name + "&action=" + BuyServlet.ACTION_UNBUY + "'>" + name + "</a></td> <td>" + price + "</td> </tr>");
                }
            }

            out.println("</table>");
            out.println("<span style=\"font-size: 10px;\">Click an item to remove it from the shopping cart</span>");

            out.println("      </td>");


            out.println("      <td rowspan='2'>");
            // page content goes here
        } catch (IOException e) {
            e.printStackTrace();
        }

        return EVAL_BODY_INCLUDE;
    }


    public int doEndTag() throws JspException {
        JspWriter out = pageContext.getOut();

        try {
            out.println("        </td>");
            out.println("    </tr>");

            // other stuff
            out.println("    <tr>");
            out.println("        <td>");

            out.println(" <a href='listall.jsp'>List all items</a><br>");

            if ( AdminOnlyTag.checkIsAdmin(pageContext.getSession(), pageContext.getServletContext()) ) {
                out.println(" <a href='adminlist.jsp'>Admin functions</a><br>");
            }

            out.println("        </td>");
            out.println("    </tr>");

            out.println("</table>");

        } catch (IOException e) {
            e.printStackTrace();
        }
        return EVAL_PAGE;
    }

    public void setPagetitle(String aPageTitle) {
        mPageTitle = aPageTitle;
    }

    public void setTitlecolor(String aTitleColor) {
        mTitleColor = aTitleColor;
    }

    public void release() {
        mPageTitle = "";
        mTitleColor = DEF_TITLE_COLOR;
    }
}


/*
    public int doEndTag() throws JspException {

        JspWriter out = pageContext.getOut();

        out.println("<table border=\"1\" cellspacing=\"0\" cellpadding=\"0\" width=\"1%\">");
        out.println("  <tr bgcolor=\"#EEEEEE\"> <td>Name</td> <td>Price</td> </tr>");

        Hashtable data = (Hashtable) pageContext.getSession().getAttribute(Constants.SHOPPING_CART);
        Enumeration keys = data.keys();

        while (keys.hasMoreElements()) {
            String name = (String) keys.nextElement();
            String price = (String) data.get(name);

            out.println("<tr> <td>" + name + "</td> <td>" + price + "</td> </tr>");
        }

        out.println("</table>");
        return EVAL_PAGE;
    }
*/